﻿using Kendo.Mvc.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebApplication1.Models;
using Kendo.Mvc.Extensions;
using System.Data;

namespace WebApplication1.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(string id)
        {
            ViewBag.stringID = id;
            return View();
        }

        public ActionResult GridHierarchy()
        {
            return View();
        }

        public ActionResult WindowGrid()
        {
            return View();
        }

        public ActionResult GridEditDropDown()
        {
            ViewData["ProductCategories"] = GetProductCategories();
            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact(string ProductName)
        {
            ViewBag.ProductName = ProductName;

            ViewBag.Message = "Your ProductName.";

            return PartialView("MyPartialView");
        }

        public ActionResult DropDownBound()
        {
            ViewData["ProductCategories"] = GetProductCategories();
            return View();
        }

        public ActionResult BatchSearch()
        {
            return View();
        }

        public ActionResult Read1([DataSourceRequest]DataSourceRequest request)
        {
            throw new InvalidOperationException("Error is thrown !!");
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Create1([DataSourceRequest] DataSourceRequest request, ProductViewModel product)
        {
            return Json(new[] { product }.ToDataSourceResult(request, ModelState));
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Update1([DataSourceRequest] DataSourceRequest request, ProductViewModel product)
        {
            return Json(new[] { product }.ToDataSourceResult(request, ModelState));
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Destroy1([DataSourceRequest] DataSourceRequest request, ProductViewModel product)
        {
            return Json(new[] { product }.ToDataSourceResult(request, ModelState));
        }

        public ActionResult Read([DataSourceRequest]DataSourceRequest request)
        {
            return Json(GetProducts().ToDataSourceResult(request));
        }

        public ActionResult ReadOrders(int productID, [DataSourceRequest]DataSourceRequest request)
        {
            return Json(GetOrders(productID).ToDataSourceResult(request));
        }

        public ActionResult ReadOrdersClean([DataSourceRequest]DataSourceRequest request)
        {
            return Json(GetOrders(80).ToDataSourceResult(request));
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Create([DataSourceRequest] DataSourceRequest request, ProductViewModel product)
        {
            return Json(new[] { product }.ToDataSourceResult(request, ModelState));
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Update([DataSourceRequest] DataSourceRequest request, ProductViewModel product)
        {
            ModelState.AddModelError("ProductName", "My server error");



            //TODO: implement create functionality

            return Json(ModelState.ToDataSourceResult());
            //return Json(new[] { product }.ToDataSourceResult(request, ModelState));
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Destroy([DataSourceRequest] DataSourceRequest request, ProductViewModel product)
        {
            return Json(new[] { product }.ToDataSourceResult(request, ModelState));
        }

        [HttpPost]
        public ActionResult Excel_Export_Save(string contentType, string base64, string fileName)
        {
            var fileContents = Convert.FromBase64String(base64);

            return File(fileContents, contentType, fileName);
        }

        private static IEnumerable<ProductViewModel> GetProducts()
        {
            Random r = new Random();
            List<ProductViewModel> collection = new List<ProductViewModel>();
            for (int i = 1; i < 100; i++)
            {
                if (i == 3)
                {
                    collection.Add(new ProductViewModel()
                   {
                       ID = i,
                       ProductCategoryId = "New",
                       isEnabled = true,
                       ProductName = null,
                       UnitsOnOrder = i,
                       UnitPrice = 10.45M + i,
                       UnitsInStock = i + 3,
                       CreditCardNumber = "123456789",
                       CustomDate = DateTime.Now.AddHours(i),
                       Doc = "<strong>Test1</strong>&lt;p&gt;&lt;strong&gt;test&lt;/strong&gt;&lt;/p&gt;",
                       Status = "PPT"
                   });
                }
                else if (i > 10)
                {
                    collection.Add(new ProductViewModel()
                    {
                        ID = i,
                        ProductCategoryId = "C1",
                        isEnabled = true,
                        ProductName = "ProductName" + r.Next(100).ToString(),
                        UnitsOnOrder = i,
                        UnitPrice = 10.45M + i,
                        UnitsInStock = i + 3,
                        CreditCardNumber = "123456789",
                        CustomDate = DateTime.Now.AddHours(i),
                        Doc = "<strong>Test1</strong>&lt;p&gt;&lt;strong&gt;test&lt;/strong&gt;&lt;/p&gt;",
                        Status = "PPT"
                    });
                }
                else
                {
                    collection.Add(new ProductViewModel()
                    {
                        ID = i,
                        ProductCategoryId = "C" + i,
                        isEnabled = false,
                        ProductName = "ProductName" + r.Next(100).ToString(),
                        UnitsOnOrder = i,
                        UnitPrice = -1 * 10.45M + i,
                        UnitsInStock = i + 3,
                        CreditCardNumber = "987654321",
                        CustomDate = DateTime.Now.AddHours(i),
                        Doc = "<strong>Test</strong>&lt;p&gt;&lt;strong&gt;test&lt;/strong&gt;&lt;/p&gt;"
                    });
                }
            }

            return collection.AsEnumerable<ProductViewModel>();
        }

        private static IEnumerable<OrderModel> GetOrders(int productID)
        {
            return Enumerable.Range(1, productID).Select(x => new OrderModel()
            {
                OrderID = x,
                OrderDate = DateTime.Now.AddDays(x * 3),
                Freight = x * 3.24M,
                ShipName = "Name " + x,
                ShipCountry = "Country " + x
            });
        }

        private static IEnumerable<ProductViewModel> GetProducts1()
        {
            Random r = new Random();
            List<ProductViewModel> collection = new List<ProductViewModel>();
            for (int i = 1; i < 100; i++)
            {
                if (i > 10)
                {
                    collection.Add(new ProductViewModel() { ID = i + 1000, isEnabled = true, CreditCardNumber = "123456789", ProductName = "ProductName" + r.Next(100).ToString(), UnitsOnOrder = i, UnitPrice = 10.45M + i, UnitsInStock = i + 3, Doc = "<ol> <li>Details.cshtml</> <li>late.csv</> <li>test.xml</> </ol>" });
                }
                else
                {
                    collection.Add(new ProductViewModel() { ID = i + 1000, isEnabled = false, CreditCardNumber = "123456789", ProductName = "ProductName" + r.Next(100).ToString(), UnitsOnOrder = i, UnitPrice = -1 * 10.45M + i, UnitsInStock = i + 3, Doc = "<ol> <li>Details.cshtml</> <li>late1.csv</> <li>test.xml</> </ol>" });
                }
            }

            return collection.AsEnumerable<ProductViewModel>();
        }

        private static IEnumerable<ProductCategory> GetProductCategories()
        {
            Random r = new Random();
            List<ProductCategory> collection = new List<ProductCategory>();
            for (int i = 1; i < 10; i++)
            {
                collection.Add(new ProductCategory()
                {
                    ProductCategoryID = "C" + i,
                    CategoryName = "C" + i + " description"
                });
            }

            return collection.AsEnumerable<WebApplication1.Models.ProductCategory>();
        }

        public ActionResult DocumentDownload1()
        {
            string contentType = "application/xlsx";
            string filePath = Server.MapPath("test1.xlsx");
            return File(filePath, contentType, "YourFileName.xlsx");
        }
    }
}